#!/usr/bin/python

import ast
import sys
import StringIO
from random import randint
import unparse
from inliningtools import hash

class inlinerTransformer(ast.NodeTransformer):
    def visit_Assign(self, node):
        to_inline=""
        for target in node.targets:
            to_inline+="shadow['"+target.id+"'] = lev("+str(vars_node(node.value))+")\n"
            to_inline+="dependencies['"+target.id+"'] = pc | dep("+str(vars_node(node.value))+")\n"
            #to_inline+="kappa['"+node.pp+"'] |= pc | dep("+str(vars_node(node.value))+")\n"
        out=ast.parse(to_inline)
        out.body+=[node]
        return out

    def visit_Exec(self, node):
        output = StringIO.StringIO()
        unparse.Unparser(node.body,output)
        s_code=output.getvalue()
        pc_prime='pc_'+str(randint(0,10**10))
        h='h_'+str(randint(0,10**10))
        ret_code=pc_prime+"=copy(pc)\n"
        ret_code+="from inliner_dep import hash,trans\n"
        ret_code+="pc|=set(['"+node.pp+"'])\n"
        ret_code+="kappa['"+node.pp+"'] |= "+ pc_prime +"| dep("+str(vars_node(node.body))+")\n"
        ret_code+="delta['"+node.pp+"'] |= lev("+str(vars_node(node.body))+")\n"
        ret_code+="code="+s_code+"\n"
        ret_code+=h+"=hash(code)\n"
        ret_code+="kappa|=Kappa("+h+")\n"
        ret_code+="eval(compile(trans(code),'eval_"+h+"', 'exec'))\n"
        ret_code+="delta['"+node.pp+"'] |= secLevel(kappa.depsIn("+h+").dom)\n"
        ret_code+="pc="+pc_prime+"\n"
        return ast.parse(ret_code)

    def visit_If(self, node):
        pc_prime='pc_'+str(randint(0,10**10))
        to_inline_b=pc_prime+"=copy(pc)\n"
        to_inline_b+="pc|=set(['"+node.pp+"'])\n"
        to_inline_b+="kappa['"+node.pp+"'] |= "+ pc_prime +"| dep("+str(vars_node(node.test))+")\n"
        to_inline_b+="delta['"+node.pp+"'] |= lev("+str(vars_node(node.test))+")\n"
        out_b=ast.parse(to_inline_b)
        node.body= [ self.visit(stmt) for stmt in node.body]
        node.orelse= [ self.visit(stmt) for stmt in node.orelse]
        to_inline_a="pc="+pc_prime
        out_a=ast.parse(to_inline_a)
        out_b.body+=[node]+out_a.body
        return out_b

    def visit_While(self, node):
        pc_prime='pc_'+str(randint(0,10**10))

        to_inline_o="kappa['"+node.pp+"'] |= "+ pc_prime +"| dep("+str(vars_node(node.test))+")\n"
        to_inline_o+="delta['"+node.pp+"'] |= lev("+str(vars_node(node.test))+")\n"
        out_o=ast.parse(to_inline_o)

        to_inline_b=pc_prime+"=copy(pc)\n"
        to_inline_b+="pc|=set(['"+node.pp+"'])\n"
        out_b=ast.parse(to_inline_b)

        to_inline_a="pc="+pc_prime+"\n"
        to_inline_a+="kappa['"+node.pp+"'] |= "+ pc_prime +"| dep("+str(vars_node(node.test))+")\n"
        to_inline_a+="delta['"+node.pp+"'] |= lev("+str(vars_node(node.test))+")\n"
        out_a=ast.parse(to_inline_a)

        node.body= out_b.body + [ self.visit(stmt) for stmt in node.body ] + out_a.body

        out_o.body+=[node]
        return out_o

    def visit_Call(self, node):
        if type(node.func) != ast.Name or node.func.id != 'output':
            return self.generic_visit(node)
        to_inline="kappa['"+node.pp+"'] |= pc | dep("+str(vars_node(node.args[0]))+")\n"
        to_inline+="kappa.ssinks+=['"+node.pp+"']\n"
        condition1="secLevel(set(['"+node.pp+"'])) <= LOW"
        condition2="shadow['"+node.args[0].id+"'] <= LOW"
        to_inline+="if "+ condition1+" and "+condition2+": output\nelse: error()"
        out=ast.parse(to_inline)
        out.body[2].body[0].value=node
        return out

    def visit_Expr(self, node):
        try:
            for stmt in ast.parse(node.value.s).body:
                if type(stmt)==ast.Assign:
                    out=ast.parse("shadow['"+stmt.targets[0].id+"']="+stmt.value.id)
                    return out.body[0]
        except:
            return self.generic_visit(node)

def vars_node(node):
    # FIXME: hay que ver que otras cosas puede haber en un value de una assign
    if   type(node)==ast.Name   : return [node.id]
    elif type(node)==ast.Str    : return []
    elif type(node)==ast.Num    : return []
    elif type(node)==ast.Subscript:
        return vars_node(node.value) # vars_node(sec[0])=vars_node(sec)
    elif type(node)==ast.BinOp  : return vars_node(node.left)+vars_node(node.right)
    elif type(node)==ast.Compare:
        ret= vars_node(node.left)
        [ret.extend(vars_node(i)) for i in node.comparators]
        return ret
    elif type(node)==ast.Call:
        ret=[]
        if node.args: [ret.extend(vars_node(i)) for i in node.args]
        return ret

def trans(source,pre_inline='',post_inline=''):
    hs=hash(source)
    code=ast.parse(source)
    ast.stmt.hs=hs
    ast.expr.hs=hs
    def program_point(self): return "%s:%s:%s" % (self.hs,self.lineno,self.col_offset)
    ast.stmt.pp=property(program_point)
    ast.expr.pp=property(program_point)

    inliner=inlinerTransformer()
    inliner.visit(code)
    out=ast.parse(pre_inline)
    post=ast.parse(post_inline)
    out.body+=code.body+post.body

    output = StringIO.StringIO()
    unparse.Unparser(out,output)
    return output.getvalue()

if __name__ == "__main__":
    from optparse import OptionParser
    parser = OptionParser()
    parser.add_option("-d", "--deps", action="store_true", dest="graph", default=False, help="inline the stmt to print the graph -in dot format- at the end of the program.")

    (options, args)=parser.parse_args()
    source=open(sys.argv[-1]).read()
    hs=hash(source)
    pre_inline='''
from inliningtools import ddict, LOW, HIGH, copy, Kappa

shadow=ddict(LOW)
dependencies=dict()
pc=set()
kappa=Kappa("'''+hs+'''")
delta=ddict(LOW)

def lev(ex):
    ret=LOW
    if not ex: return ret
    for x in ex:
        ret|=shadow[x]
    return ret

def dep(ex):
    ret = set()
    if not ex: return ret
    for x in ex:
        try:
            ret |= dependencies[x]
        except KeyError:
            pass
    return ret

def secLevel(pps):
    ret=LOW
    for pp in pps:
        ret|=checktransitivity(pp,done=set())
    return ret

def checktransitivity(pp,done=set()):
    ret=delta[pp]
    if pp in done: return ret
    done.add(pp)
    for i in kappa[pp]:
        ret|=checktransitivity(i,done)
    return ret

def error():
    print '//ERROR'
'''
    post_inline="kappa.save()"
    print trans(source,pre_inline,post_inline)
    if options.graph:
        print 'print kappa.graph(delta)'
